#include <CONIO.H>
#include <STDLIB.H>
#include <TIME.H>
#include <STRING.H>
#include <STDIO.H>
#include <DIR.H>

const int YES = 1;
const int NO = 0;
const int TRUE = 1;
const int FALSE = 0;

char** ants;
char cwd[256];
char name[21];
int fileio;
int num_of_ants = 500;
int gene_length = 60;

void insert_rand_strings();
void error(char* str);
int yesno();

int main()
	{

	clrscr();

	cputs(
	"\n\r About this program:"
	"\n\r     This program is an Artificial Intelligence research program."
	"\n\r It employs genetic algorithm for evolving intelligence into a "
	"\n\r group of ants. The intelligence is here simulated into crossing "
	"\n\r a Muir trail (or some other trail). Starting from random strings as"
	"\n\r their genes, using reproduction and mutation, they start to learn "
	"\n\r to cross the trail. The ants with strongest fitness value are chosen"
	"\n\r to reproduce for the next generation. "
	"\n\r Continue to run program(Y/N)?"
	);
	if (yesno() == NO) exit(2);

	cputs("\n\rStart a New instance or open some previous instance(Y=new/N=open)?");
	if ( yesno() == NO )
		{
		cputs ("\n\r Name of Instance: ");
		char temp[23];
		temp[0] = 20;
		cgets(temp);
		strcpy(name, temp+2);

		cputs (
			"\n\r If you use no file input/output, "
			"\n\r the number of ants is limited to 600, and length of genes to 60."
			"\n\r If you use file input/output,"
			"\n\r there is no limit. Also, you will be able to resume work on a "
			"\n\r previous instance or analyse the process. Only the disadv"
			"\n\r is that the speed will be slow."
			);

		cputs (" Use file input/output?(Y/n)");
		if ( yesno() == YES ) fileio = TRUE; else fileio = FALSE;

		cputs (" Number of ants in the group(if not sure, take 600): ");
		scanf("%d", &num_of_ants);

		cputs(" Length of genes for each ant in bytes(if not sure, take 60): ");
		scanf("%d", &gene_length);

		if ( (num_of_ants > 600) || (gene_length>60) )
			{
			cputs("\n\r As your values exceeded the limits, file i/o is BEING used.");
			fileio = TRUE;
			}

		if (fileio == TRUE)
			{
			char temp[13];
			cputs("Name of new directory : ");
			gets(temp);
			cputs("Path where the new directory is to be created: ");
			gets(cwd);

			if (chdir(cwd))
				error("Some error in path. Cannot continue.");
			if (mkdir(temp))
				error("Error creating directory. Cannot continue.");
			if (chdir (temp))
				error("Error moving to the new directory. Cannot continue.");
			strcat(cwd, temp);
			}
		}
	else
		{
		cputs("Give the path to the directory containing the files: ");
		gets(cwd);

		if (chdir(cwd))
			error("Invalid Path");


		//tk

		}

	clrscr();
	cputs("\nInitializing with random values...");
	insert_rand_strings();
	cputs("done.\n");



	//start of generation
	//step 1: insert random strings for ants
	//step 2: let the ants loose on the trail and get fitness value for each
	//step 3: statistical analysis: avg, best etc.
	//step 4: select the best 10% of them and copy them over the others
	//step 5: reproduction and mutation
	//step 6: goto step 2

	getch();
	return 0;
	}

void allocate()
	{
	// allocate ants strings space in memory = ants array
	ants = (char**) malloc(num_of_ants*sizeof(char*));
	if (ants==NULL)
		{
		cputs("Very less memory!");
		getch();
		exit(1);
		}
	for (int i=0; i<=num_of_ants-1; i++)
		if ( ( ants[i] = (char*) malloc(gene_length*sizeof(char)) ) == NULL)
			{
			cprintf("No available memory while allocating ant no. %d!",i);
			getch();
			exit(1);
			}

	}

void insert_rand_strings()
	{
	randomize();

	for (int i=0; i<num_of_ants; i++)
		for(int j =0; j<gene_length; j++)
			ants[i][j] = random(256);

	}

int yesno()
	{
	char ch;

	while(1)
		{
		ch = getch();
		if ( (ch=='y') || (ch=='Y') ) { cputs("Y\r\n"); return YES; }
		if ( (ch=='n') || (ch=='N') ) { cputs("N\r\n"); return NO; }
		}

	}

void error(char* str)
	{
	puts("\n");
	puts(str);
	getch();
	exit(1);
	}
