
#include <GRAPHICS.H>
#include <CONIO.H>
#include <STDIO.H>
#include <STRING.H>
#include <STDLIB.H>
#include <DOS.H>
#include <ASSERT.H>
#include "MOUSE.H"

const int BLK_HGT = 12;
const int BLK_WDTH = 18;

int gridx, gridy;
int grid[32][32];
int cur_num;
char filename[255] = "";
mouse_manager mouse;

void draw_grid();
void disp_num(int, int, int);
void disp_num_all(int);
void main_loop();
void empty_grid();
int write_grid_into_file(char* file);
int read_file_into_grid(char* file);
void draw_screen();
int hit_test(int, int);
void delete_block(int);
void insert_block(int);
void fill_block(int);
void status(char*);

void main()
	{
	clrscr();

	draw_screen();

	main_loop();

	mouse.conceal();
	closegraph();
	}

void draw_grid()
	{
	int i;

	gridx = 320 - (BLK_WDTH*32)/2;
	gridy = 240 - (BLK_HGT*32)/2;

	//vertical lines
	for (i =0; i<=32; i++)
		line(gridx+i*BLK_WDTH, gridy, gridx+i*BLK_WDTH, gridy+32*BLK_HGT);

	//horizontal lines
	for (i =0; i<=32; i++)
		line(gridx, gridy+i*BLK_HGT, gridx+32*BLK_WDTH, gridy+i*BLK_HGT);

	char number[3];

	//write numbers
	for (i=0; i<=31; i++)
		{
		sprintf(number,"%02d", i);
		outtextxy(gridx+i*BLK_WDTH+2, gridy-9, number);		//column
		outtextxy(gridx-20, gridy+i*BLK_HGT+3, number);         //row
		}

	}

void disp_num_all(int clear_prev)
	{
	for(int i=0; i<=31; i++)
		for(int j=0; j<=31; j++)
			if (clear_prev || grid[i][j])
				disp_num(i,j,grid[i][j]);
	}

void disp_num(int c, int r, int n)
	{
	if (n==0)
		{
		mouse.conceal();
		setfillstyle(SOLID_FILL, BLACK);
		bar (gridx+c*BLK_WDTH+1, gridy+r*BLK_HGT+1,
					gridx+(c+1)*BLK_WDTH-1, gridy+(r+1)*BLK_HGT-1 );
		mouse.display();
		return;
		}

	char number[3];
	sprintf(number, "%02d", n);
	setcolor (WHITE);
	mouse.conceal();
	outtextxy(gridx+c*BLK_WDTH+2, gridy+r*BLK_HGT+2, number);
	mouse.display();
	}

void main_loop()
	{
	if (!mouse.reset())
		{
		closegraph();
		clrscr();
		printf("No mouse! Program cannot run!");
		exit(1);
		}
	mouse.display();

	char text[100];
	cur_num = 0;

	while (1)
		{
		int t;
		char ch;
		if (kbhit())
			{
			char command = getch();
			switch(command)
				{

				case 'n': case 'N':		//NEW GRID
					empty_grid();
					disp_num_all(1);
					cur_num=0;
					break;

				case 'o': case 'O':		//OPEN GRID
					mouse.conceal();
					closegraph();
					clrscr();
					printf("Open file name: ");
					scanf("%s", text);
					if (strchr(text,'.') == NULL) strcat(text, ".GRD");

					if ((t = read_file_into_grid(text)) != 0)
						{
						printf("\nFile is corrupted! Error #%d", t);
						printf("\nPress a key...");
						getch();
						}
					else
						strcpy(filename, text);

					draw_screen();
					mouse.display();
					disp_num_all(0);		//0 means dont erase prev numbers
					break;

				case 's': case 'S':
					if (filename[0]!=0)
						{
						char temptext[50];
						sprintf(temptext, "Save onto the file %s (Y/N)?", filename);
						status(temptext);

						do
							ch = getch();
						while (ch!='y' && ch!= 'Y' && ch!='n' && ch!= 'N');

						status(" ");

						if (ch=='n' || ch=='N') break;

						write_grid_into_file(filename);
						status("File successfully saved.");
						break;
						}
													//fall through
				case 'a': case 'A':
					mouse.conceal();
					closegraph();

					clrscr();
					printf("Save file name: ");
					scanf("%s", text);
					if (strchr(text,'.') == NULL) strcat(text, ".GRD");

					if (write_grid_into_file(text))
						{
						printf("\n Cannot write to file!");
						printf("\n Press a key to continue");
						getch();
						}
					else
						strcpy(filename, text);

					draw_screen();
					mouse.display();
					disp_num_all(0);
					status("File successfully saved.");
					break;

				case 'x': case 'X':
					status("Unsaved work will be lost. Really quit(Y/N)");

					do
						ch = getch();
					while (ch!='y' && ch!= 'Y' && ch!='n' && ch!= 'N');

					if (ch=='y' || ch=='Y') return;

					status (" ");
					break;

				default :
					sound(1000);
					delay(500);
					nosound();
				}
			}
		if (mouse.was_button_pressed(0))	//was mouse left button pressed
			{
			int box = hit_test (mouse.get_x(), mouse.get_y());
			if (box!=-1)		//mouse pressed inside grid
				{
				if ( grid[box/32][box%32] )
					//if left mouse_button pressed on a filled block,
					// then interprete it as delete,
					delete_block(box);

				else	//else it is a instruc to fill that block with next num
					fill_block(box);
				}
			}
		if (mouse.was_button_pressed(1)) //was mouse right  button pressed
			{
			int box = hit_test (mouse.get_x(), mouse.get_y());
			if (box!=-1)		//mouse pressed inside grid
				{
				if ( grid[box/32][box%32] )
					//if left mouse_button pressed on a filled block,
					// then interprete it as delete,
					delete_block(box);

				else	//else it is a instruc to fill that block with next num
					insert_block(box);
				}
			}
		}
	}

void draw_screen()
	{
	int gd=VGA, gm=VGAHI;
	initgraph(&gd, &gm, "c:\\tc\\bgi");

	char text[100];

	strcpy(text, "THE GRID MAKER");
	setcolor(RED);
	outtextxy(250, 0, text);

	strcpy(text, "Operations:    New  |  Open  |  Save  |  saveAs  |  eXit");
	setcolor (YELLOW);
	outtextxy(90, 14, text);

	setcolor(CYAN);
	draw_grid();

	}

void empty_grid()
	{
	for(int i=0; i<=31; i++)
		for(int j=0; j<=31; j++)
			grid[i][j] = 0;
	}

int read_file_into_grid(char* file)
	{
	int i,j;
	FILE* fp = fopen ( file, "rb");

	if (fp==0)	return 1;		//error

	fseek(fp, 0,SEEK_END);
	long int fl = ftell(fp);
	if (fl!=1024) return 2;		//error
	fseek(fp, 0, SEEK_SET);

	for(i=0; i<=31; i++)
		for (j=0; j<=31; j++)
			if ( fread(&grid[i][j], sizeof(char), 1, fp) != 1)
				{
				fclose(fp);
				return 3;       //error
				}
	fclose(fp);

	cur_num=0;
	for(i=0; i<=31; i++)
		for ( j=0; j<=31; j++)
			if (grid[i][j] > cur_num)
				cur_num = grid[i][j];

	return 0;
	}

int write_grid_into_file(char* file)
	{
	FILE* fp = fopen(file, "wb");
	if (fp==0) return 1;

	for(int i=0; i<=31; i++)
		for (int j=0; j<=31; j++)
			if ( fwrite(&grid[i][j], sizeof(char), 1, fp) != 1)
				{
				fclose(fp);
				return 1;       //error
				}
	fclose(fp);

	return 0;

	}

int hit_test(int x, int y)
	{
	if (x<gridx || y<gridy) return -1;

	int boxx = (x-gridx) / BLK_WDTH;
	int boxy = (y-gridy) /BLK_HGT;

	if (boxx >= 32 || boxy >= 32) return -1;

	return (boxx*32 + boxy);
	}

void delete_block(int bl)
	{
	if (grid[bl/32][bl%32]==cur_num)
		{			//if last number, then just erase last number
		grid[bl/32][bl%32] = 0;
		disp_num(bl/32, bl%32, 0);
		cur_num--;
		return;
		}

	int to_find = grid[bl/32][bl%32] + 1;

	grid[bl/32][bl%32] = 0;
	disp_num(bl/32, bl%32, 0);

	while(1)
		{
		int result = -1;
		for(int i=0; i<=31;i++)
			for(int j=0; j<=31; j++)
				if (grid[i][j] == to_find)
					{
					result = i*32+j;
					break;
					}
		assert(result!=-1);

		grid[result/32][result%32] = to_find-1;
		disp_num(result/32, result%32, 0);	//delete previous number
		disp_num(result/32, result%32, to_find-1);

		if (to_find==cur_num) break;
		to_find++;
		}

	cur_num--;
	}

void insert_block(int bl)
	{
	int num;

	mouse.conceal();
	closegraph();
	clrscr();

	cputs("Enter the number to insert: ");
	scanf("%d", &num);

	if (num <1 || num>cur_num+1)
		{
		printf("\n Number should be between 1 and %d inclusive", cur_num+1);
		cputs("\r\n Press a key...");
		getch();

		draw_screen();
		mouse.display();
		disp_num_all(0);

		return;

		}

	draw_screen();
	mouse.display();
	disp_num_all(0);

	if (num==cur_num+1)
		{
		fill_block(bl);
		return;
		}

	int to_find = cur_num;

	while(1)
		{
		int result = -1;
		for(int i=0; i<=31;i++)
			for(int j=0; j<=31; j++)
				if (grid[i][j] == to_find)
					{
					result = i*32+j;
					break;
					}
		assert(result!=-1);

		grid[result/32][result%32] = to_find+1;
		disp_num(result/32, result%32, 0);	//delete previous number
		disp_num(result/32, result%32, to_find+1);

		if (to_find==num) break;
		to_find--;
		}

	grid[bl/32][bl%32] = num;
	disp_num(bl/32, bl%32, num);

	cur_num++;

	}

void fill_block(int block)
	{
	cur_num++;
	grid[block/32][block%32] = cur_num;
	disp_num (block/32, block%32, cur_num);
	}

void status(char* text)
	{
	setfillstyle(SOLID_FILL, BLACK);
	bar(1, 460, 639, 475);

	int width = textwidth(text);

	if (width > 600) return;

	setcolor(WHITE);
	outtextxy(320-width/2, 460, text);

	}

